//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include <Registry.hpp>
#include "test1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
String RKey;
PPropInfo PropInfo;
Longint OW,OH,OP;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------


void __fastcall TForm1::FormCreate(TObject *Sender)
{
bool B;
int I,J;
HKEY CurrentKey;
TRegistry *Reg;
String R1,R2;
  // xs  Form width , height , PixelsPerInch
  OW = Form1->Width;
  OH = Form1->Height;
  OP = Form1->PixelsPerInch;
  RKey = "\FormAutoSize";
  Reg = new TRegistry(); //Reg := TRegistry.Create;  //-----Crano-----
try
 {
  Reg->RootKey = HKEY_CURRENT_USER;
    if (Reg->KeyExists(RKey))
      Reg->DeleteKey(RKey);
      Reg->CreateKey(RKey);
    // xsӤW
     for (int I = 0 ;I<ComponentCount; I++)
       {
        if(Components[I]!="TControl")
          continue;
          Reg->OpenKey(RKey,False);
             if(Components[I]=="TControl")
               { R1 = TControl(Components[I]).Name;}

          if(!Reg->KeyExists(RKey+"\\"+R1))  // if not Reg.KeyExists(RKey+'\'+R1) then
            Reg->CreateKey(R1);            //-----Crano-----

            Reg->OpenKey(R1,True);
            Reg->WriteInteger("Top",TControl(Components[I]).Top);
            Reg->WriteInteger("Left",TControl(Components[I]).Left);
            Reg->WriteInteger("Width",TControl(Components[I]).Width);
            Reg->WriteInteger("Height",TControl(Components[I]).Height);

           // Have Font
            PropInfo = GetPropInfo(Components[I], "Font");
            if (PropInfo != NULL)
              {
               Reg->WriteInteger("FontSize",TEdit(Components[I]).Font->Size);
               Reg->WriteInteger("FontHeight",TEdit(Components[I]).Font->Height);
              }
            // Have Panels
            PropInfo = GetPropInfo(Components[I], "Panels");
            if (PropInfo != NULL && TStatusBar(Components[I]).Panels->Count > 0)
               {
               if (!Reg->KeyExists("Panels"))
                  Reg->CreateKey("Panels");
               Reg->OpenKey("Panels",True);
                 for (J = 0 ; J<TStatusBar(Components[I]).Panels->Count;J++)
                   {
                  // Reg->WriteInteger(IntToStr(J),TStatusBar(Components[I]).Panels,3);
                   }
               }
            // Have Columns
            PropInfo = GetPropInfo(Components[I], "Columns");
             if (PropInfo != NULL && TDBGrid(Components[I]).Columns->Count > 0)
               {
               if (!Reg->KeyExists("Columns"))
                   Reg->CreateKey("Columns");
                Reg->OpenKey("Columns",True);
                 for (J = 0; J<TDBGrid(Components[I]).Columns->Count ; J++)
                    {
                   //Reg->WriteInteger("Width"+IntToStr(J),TDBGrid(Components[I]).Columns[J]);
                   //Reg->WriteInteger("FontSize"+IntToStr(J),TDBGrid(Components[I]).Columns[J]);
                   //Reg->WriteInteger("FontHeight"+IntToStr(J),TDBGrid(Components[I]).Columns[J]);
                   //Reg->WriteInteger("TitleFontSize"+IntToStr(J),TDBGrid(Components[I]).Columns[J]);
                   //Reg->WriteInteger("TitleFontHeight"+IntToStr(J),TDBGrid(Components[I]).Columns[J]);
                    }
               }
            // Have DefaultColWidth
            PropInfo = GetPropInfo(Components[I], "DefaultColWidth");
            if (PropInfo!=NULL)
              Reg->WriteInteger("DefaultColWidth",TStringGrid(Components[I]).DefaultColWidth);
            // Have DefaultRowHeight
            PropInfo = GetPropInfo(Components[I], "DefaultRowHeight");
             if (PropInfo!=NULL)
              Reg->WriteInteger("DefaultRowHeight",TStringGrid(Components[I]).DefaultRowHeight);
             Reg->CloseKey();
        }
    }
catch(...)
    {
   Reg->Free();
   }
}
//---------------------------------------------------------------------------



void __fastcall TForm1::FormResize(TObject *Sender)
{
TRegistry *Reg;
int I,J ;
Longint T,L,W,H,FS,FH;
Longint NW,NH,NP ;

  NW = Form1->Width;
  NH = Form1->Height;
  NP = Form1->PixelsPerInch;
  Reg = new TRegistry();
try
  {
    Reg->RootKey = HKEY_CURRENT_USER;
    Reg->OpenKeyReadOnly(RKey);
    for (I = 0 ; I<ComponentCount ;I++)
      {
        if(Components[I]!="TControl")
           continue;
        if (Reg->OpenKeyReadOnly(RKey+'\\'+TControl(Components[I]).Name))
           {
           T = Reg->ReadInteger("Top");
           L = Reg->ReadInteger("Left");
           W = Reg->ReadInteger("Width");
           H = Reg->ReadInteger("Height");
           if (OH != 0)
             TControl(Components[I]).Top = Longint(T*NH/OH) ;
           if (OW != 0)
             TControl(Components[I]).Left = Longint(L*NW/OW);
           if (OW != 0)
             TControl(Components[I]).Width = Longint(W*NW/OW);
           if (OH != 0)
             TControl(Components[I]).Height = Longint(H*NH/OH);
           // ˬdO_ font property
           PropInfo = GetPropInfo(Components[I], "Font");
           if (PropInfo != NULL)
             {
//              FS := Reg.ReadInteger('FontSize');
              FH = Reg->ReadInteger("FontHeight");
              if (OP != 0 && OW != 0 && OH != 0)
                {
                 TEdit(Components[I]).Font->Size = Longint((FS * NP/OP) * NH / OH);
                 TEdit(Components[I]).Font->Height = Longint((FH * NP/OP) * NH / OH);
                }
             }
           // Have Panels
           PropInfo = GetPropInfo(Components[I], "Panels");
           if (PropInfo != NULL && TStatusBar(Components[I]).Panels->Count > 0)
              {
               Reg->OpenKeyReadOnly("Panels");
               for (J = 0 ; J<TStatusBar(Components[I]).Panels->Count ;J++)
                 {
                   W = Reg->ReadInteger(IntToStr(J));
                   //TStatusBar(Components[I]).Panels[J].Width;//= Longint(W * NW / OW);
                 }
              }
           // Have Columns
           PropInfo = GetPropInfo(Components[I],"Columns");
           if (PropInfo != NULL && TDBGrid(Components[I]).Columns->Count > 0)
              {
               Reg->OpenKeyReadOnly("Columns");
               for (J = 0 ; J<TDBGrid(Components[I]).Columns->Count ; J++)
                  {
                   W = Reg->ReadInteger("Width"+IntToStr(J));
                  // TDBGrid(Components[I]).Columns[J] = Longint(W * NW / OW);
//                   FS := Reg.ReadInteger('FontSize'+IntToStr(J));
                   FH = Reg->ReadInteger("FontHeight"+IntToStr(J));
                   // `N  font.size  font.height |ۤv  ҥHܤ@Yi
                  // TDBGrid(Components[I]).Columns[J].Font.Size   := Longint((FS * NP div OP) * NH div OH);
                  // TDBGrid(Components[I]).Columns[J].Font.Height := Longint((FH * NP div OP) * NH div OH);
//                   FS := Reg.ReadInteger('TitleFontSize'+IntToStr(J));
                   FH = Reg->ReadInteger("TitleFontHeight"+IntToStr(J));
//                   TDBGrid(Components[I]).Columns[J].Title.Font.Size   := Longint((FS * NP div OP) * NH div OH);
                  // TDBGrid(Components[I]).Columns[J].Title.Font.Height := Longint((FH * NP div OP) * NH div OH);
                   }
              }
           // Have DefaultColWidth
           PropInfo = GetPropInfo(Components[I],"DefaultColWidth");
           if (PropInfo != NULL)
              {
              W = Reg->ReadInteger("DefaultColWidth");
               if (OW != 0 )
               TStringGrid(Components[I]).DefaultColWidth  = Longint(W * NW / OW);
              }
           // Have DefaultRowHeight
           PropInfo = GetPropInfo(Components[I], "DefaultRowHeight");
           if (PropInfo != NULL)
              {
               H = Reg->ReadInteger("DefaultRowHeight");
               if (OH != 0)
                 TStringGrid(Components[I]).DefaultRowHeight = Longint(H * NH / OH);
              }
            }
          }
        Reg->CloseKey();
      }
catch(...)
    {
   Reg->Free();
   }

}
//---------------------------------------------------------------------------


